package zgs.httpd


trait HLet {
  
  //------------------- to implement ------------------------
  
  def act(talk : HTalk) : Unit
  
  //-------------------- to override ------------------------
  
  def before : Seq[HLet] = Nil
  def paramsEncoding : String = "UTF-8"
  def partsAcceptor(reqInfo : HReqHeaderData) : Option[HPartsAcceptor] = None // for multipart requests
  
  //------------------------ few helpers --------------------
    
  protected def error(status : HStatus.Value, msg : String, tk : HTalk) = new let.ErrLet(status, msg) act(tk)
  protected def error(status : HStatus.Value, tk : HTalk)               = new let.ErrLet(status) act(tk)
  protected def e404(tk : HTalk)                                        = error(HStatus.NotFound, tk)
  
  protected def redirect(to : String, tk : HTalk) = new let.RedirectLet(to) act(tk)
  
  protected def sessRedirect(to : String, tk : HTalk) : Unit =  {
    val parts = to.split("\\?", 2)
    val url = parts(0) + ";" + tk.ses.idKey + "=" + tk.ses.id + {
      if(parts.size == 2) "?" + parts(1)
      else ""
    }
    new let.RedirectLet(url) act(tk)
  }
  
  protected def delegate(to : HLet, tk : HTalk) : Unit =
    if(to.before.find(be => { be.act(tk); tk.isClosed }).isEmpty) to.act(tk)
  
}
