package zgs.httpd


protected object HResolver {

  private object errApp extends HApp {
    override def tracking  = HTracking.NotAllowed
    override def keepAlive = false
    override def chunked   = false
    override def buffered  = false 
    override def gzip      = false
    def resolve(req : HReqHeaderData) = error("not used")
    val hLet = new let.ErrLet(HStatus.NotFound)
  }
  
  def resolve(apps : Seq[HApp], req : HReqHeaderData) : (HApp, HLet) = {
    
    def doFind(idx : Int) : (HApp,HLet) = 
      if(idx == apps.size) (errApp, errApp.hLet) 
      else apps(idx).resolve(req) match {
        case Some(let) => (apps(idx), let)
        case None      => doFind(idx + 1)
      }
    
    doFind(0)
  }
}
